/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.drive.model;

/**
 * A list of shared drives.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Drive API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DriveList extends com.google.api.client.json.GenericJson {

  /**
   * The list of shared drives. If nextPageToken is populated, then this list may be incomplete and
   * an additional page of results should be fetched.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Drive> drives;

  static {
    // hack to force ProGuard to consider Drive used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(Drive.class);
  }

  /**
   * Identifies what kind of resource this is. Value: the fixed string "drive#driveList".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The page token for the next page of shared drives. This will be absent if the end of the list
   * has been reached. If the token is rejected for any reason, it should be discarded, and
   * pagination should be restarted from the first page of results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The list of shared drives. If nextPageToken is populated, then this list may be incomplete and
   * an additional page of results should be fetched.
   * @return value or {@code null} for none
   */
  public java.util.List<Drive> getDrives() {
    return drives;
  }

  /**
   * The list of shared drives. If nextPageToken is populated, then this list may be incomplete and
   * an additional page of results should be fetched.
   * @param drives drives or {@code null} for none
   */
  public DriveList setDrives(java.util.List<Drive> drives) {
    this.drives = drives;
    return this;
  }

  /**
   * Identifies what kind of resource this is. Value: the fixed string "drive#driveList".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies what kind of resource this is. Value: the fixed string "drive#driveList".
   * @param kind kind or {@code null} for none
   */
  public DriveList setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The page token for the next page of shared drives. This will be absent if the end of the list
   * has been reached. If the token is rejected for any reason, it should be discarded, and
   * pagination should be restarted from the first page of results.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * The page token for the next page of shared drives. This will be absent if the end of the list
   * has been reached. If the token is rejected for any reason, it should be discarded, and
   * pagination should be restarted from the first page of results.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public DriveList setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public DriveList set(String fieldName, Object value) {
    return (DriveList) super.set(fieldName, value);
  }

  @Override
  public DriveList clone() {
    return (DriveList) super.clone();
  }

}
