/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.drive.model;

/**
 * A list of generated file IDs which can be provided in create requests.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Drive API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GeneratedIds extends com.google.api.client.json.GenericJson {

  /**
   * The IDs generated for the requesting user in the specified space.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> ids;

  /**
   * Identifies what kind of resource this is. Value: the fixed string "drive#generatedIds".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The type of file that can be created with these IDs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String space;

  /**
   * The IDs generated for the requesting user in the specified space.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getIds() {
    return ids;
  }

  /**
   * The IDs generated for the requesting user in the specified space.
   * @param ids ids or {@code null} for none
   */
  public GeneratedIds setIds(java.util.List<java.lang.String> ids) {
    this.ids = ids;
    return this;
  }

  /**
   * Identifies what kind of resource this is. Value: the fixed string "drive#generatedIds".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies what kind of resource this is. Value: the fixed string "drive#generatedIds".
   * @param kind kind or {@code null} for none
   */
  public GeneratedIds setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The type of file that can be created with these IDs.
   * @return value or {@code null} for none
   */
  public java.lang.String getSpace() {
    return space;
  }

  /**
   * The type of file that can be created with these IDs.
   * @param space space or {@code null} for none
   */
  public GeneratedIds setSpace(java.lang.String space) {
    this.space = space;
    return this;
  }

  @Override
  public GeneratedIds set(String fieldName, Object value) {
    return (GeneratedIds) super.set(fieldName, value);
  }

  @Override
  public GeneratedIds clone() {
    return (GeneratedIds) super.clone();
  }

}
